clear, clc
close all

n_train = 10; %number of training

IN = load ('InTheMED_WP3_Case2_input_SM.txt'); 
OUT = load ('InTheMED_WP3_Case2_output_SM.txt'); 

IN = IN'; OUT = OUT';

x = IN(1:4,:); t = OUT;

Conc = zeros(n_train,7);

% verifica con rilascio da dati Ayvaz
release_true = [2074 4838 3715 3024]';
Conc_true = [0.084621482 0.604730785 0.559267759 0.875306308 0.398712546 0.002473775 0.05730271]';

for i_train = 1:n_train
    
% Choose a Training Function
% For a list of all training functions type: help nntrain
% 'trainlm' is usually fastest.
% 'trainbr' takes longer but may be better for challenging problems.
% 'trainscg' uses less memory. Suitable in low memory situations.
trainFcn = 'trainlm';  % Levenberg-Marquardt backpropagation.

% Create a Fitting Network
hiddenLayerSize = 10;
net = fitnet(hiddenLayerSize,trainFcn);

% Setup Division of Data for Training, Validation, Testing
net.divideParam.trainRatio = 70/100;
net.divideParam.valRatio = 15/100;
net.divideParam.testRatio = 15/100;

% Train the Network
[net,tr] = train(net,x,t);
% 
% Test the Network
y = net(x);
e = gsubtract(t,y);
performance = perform(net,t,y);

% Plots
% Uncomment these lines to enable various plots.
% figure, plotperform(tr)
% figure, plottrainstate(tr)
% figure, ploterrhist(e)
% figure, plotregression(t,y)

%Uncomment this line to enable to save all the 10 neural networks
% save(['net' num2str(i_train) '.mat'],'net')

Conc_sim = net(release_true);
Conc (i_train,:) = Conc_sim;

% Uncomment these lines to enable various plots.
% figure
% plot(Conc_vere,Conc_simulate,'b*')
% figure
% bar([Conc_vere Conc_simulate]), xlabel('Monitoring Point'), ylabel('Concentration mg/l'),legend('Observed','Estimated');
end

Conc_mean = mean(Conc);
figure
bar([Conc_true Conc_sim]), xlabel('Monitoring Point'), ylabel('Concentration mg/l'),legend('Observed','Estimated');
